﻿Public Class Form1
    'A4サイズの寸法は　210 × 297 ミリ
    Const PICSE_FILE As String = "hexagonholt.bmp"  '画像保存ファイル
    Const HEX_UBOLT As String = "Hexagon unc1.csv"  'ユニファイボルトのＣＳＶファイル
    Const TENP_FILE As String = "temp unc 2.csv"
    Const LEN_MARGIN As String = "len margin.csv" '胴部長さの公差ファイル　　
    Const MATERIAL_FILE As String = "material.csv"  '材料コードのＣＳＶファイル　
    Const SCREW_MARGIN As String = "screw margin.csv" '有効ネジ長さのＣＳＶファイル
    Dim selpix As Decimal = 4  '枠線のピクセルサイズ　（基本は　４）
    Dim pixs As Decimal  '実線のピクセルサイズ（基本は　４）
    Dim sizpix As Decimal = 4 '寸法線と寸法文字のピクセルサイズ（基本は4）
    Dim bitmapsize As Integer = 4
    Dim xorigin As Decimal   'ボルト頭部端面の位置（将来はココを原点に設定する） 
    Dim yorigin As Decimal = 120  'ボルトの水平方向の中心位置、六角頭部も共通（将来はココを原点にする）
    Dim hxorgin As Decimal   '六角部の中心位置　Ｘ原点

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.KeyPreview = True
        TextBox4.Enabled = False
        TextBox5.Enabled = False
    End Sub
    Private Sub Form1_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles MyBase.KeyPress
        If e.KeyChar = Chr(Keys.Enter) Then
            Me.SelectNextControl(Me.ActiveControl, True, True, True, True)
            e.Handled = True
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If TextBox1.Text = "" Then
            MsgBox("呼び径を入力してください。")
            Return
        End If
        If TextBox2.Text = "" Then
            MsgBox("Lの長さを入力してください。")
            Return
        End If

        Try
            'TextBox1の文字
            Dim txt As String
            txt = TextBox1.Text

            'TextBox1に入力されたtxt1の大文字化
            Dim txt1 As String
            txt1 = UCase(txt)

            'TextBox2のStringをDecimalに変換処理
            Dim lline As Decimal  '胴部Ｌのライン
            Dim txt2string As String 'TextBox2の初期値はString
            txt2string = TextBox2.Text  '胴部Ｌのライン
            lline = CDec(txt2string)

            'TextBox2に入力された数値文字が2文字以下の場合先頭に”0”を付ける処理
            Dim st2 As String
            Dim txt2len As String
            Dim txt2ans As String
            txt2len = txt2string.Length
            If txt2len = 1 Then     'TextBox2に入力された数値文字が1文字の場合
                st2 = txt2string.Substring(0, 1)  'TextBox2の1番目以降の1文字を取得
                txt2ans = "00" & +txt2string
            ElseIf txt2len = 2 Then   'TextBox2に入力された数値文字が2文字の場合
                st2 = txt2string.Substring(0, 2)  'TextBox2の1番目以降の2文字を取得
                txt2ans = "0" & +txt2string
            End If

            'ロケーションの処理
            '六角表示側
            Dim hxlocat As Decimal
            hxlocat = TextBox6.Text
            hxorgin = TextBox6.Text
            'ネジ側表示
            Dim xlocat As Decimal
            xlocat = TextBox7.Text
            xorigin = TextBox7.Text
            '拡大時のピクセル数の設定
            Dim pichange As Decimal
            pichange = TextBox8.Text
            pixs = TextBox8.Text

            Dim xsent As Decimal = xorigin * 4  'ｘのセンター位置(ピクセル化）将来変数化する
            Dim ysent As Decimal = yorigin * 4  'ｙのセンター位置(ピクセル化）将来変数化する
            Dim xhsnt As Decimal = hxorgin * pixs  '六角部の中心位置　Ｘ原点(ピクセル化）

            Dim g As Graphics
            PictureBox1.Image = New Bitmap(210 * bitmapsize, 297 * bitmapsize)
            g = Graphics.FromImage(PictureBox1.Image)
            Dim pb2 As New Pen(Color.Black, 2)  '線の太さ
            Dim pb3 As New Pen(Color.Black, 3)  '線の太さ　

            '文字サイズの数値
            Dim txtm As Decimal = 20 '大文字サイズ
            Dim txts As Decimal = 16 '中文字サイズ
            Dim fxize As Decimal = 12 '数値の大きさ 寸法数値
            Dim comsiz As Decimal = 9 '公差数値の大きさ


            'ココからは図面の設定
            '外枠の設定
            g.DrawRectangle(pb3, 12 * selpix, 12 * selpix, 186 * selpix, 273 * selpix)
            'ココから水平線の指定
            '上段水平線
            g.DrawLine(pb3, 12 * selpix, 243 * selpix, 198 * selpix, 243 * selpix)
            '２段目水平線
            g.DrawLine(pb2, 68 * selpix, 254 * selpix, 198 * selpix, 254 * selpix)
            '3段目水平線
            g.DrawLine(pb2, 68 * selpix, 265 * selpix, 198 * selpix, 265 * selpix)
            '４段目の水平線
            g.DrawLine(pb2, 68 * selpix, 275 * selpix, 198 * selpix, 275 * selpix)
            '寸法区分の水平線
            g.DrawLine(pb2, 12 * selpix, 249 * selpix, 68 * selpix, 249 * selpix)
            g.DrawLine(pb2, 12 * selpix, 255 * selpix, 68 * selpix, 255 * selpix)
            g.DrawLine(pb2, 12 * selpix, 261 * selpix, 68 * selpix, 261 * selpix)
            g.DrawLine(pb2, 12 * selpix, 267 * selpix, 68 * selpix, 267 * selpix)
            g.DrawLine(pb2, 12 * selpix, 273 * selpix, 68 * selpix, 273 * selpix)
            g.DrawLine(pb2, 12 * selpix, 279 * selpix, 68 * selpix, 279 * selpix)

            'ここから垂直線の指定
            '右から１列目
            g.DrawLine(pb2, 162 * selpix, 243 * selpix, 162 * selpix, 265 * selpix)
            '右から２列目
            g.DrawLine(pb2, 126 * selpix, 243 * selpix, 126 * selpix, 285 * selpix)
            '右から３列目
            g.DrawLine(pb3, 68 * selpix, 243 * selpix, 68 * selpix, 285 * selpix)
            '許容差　垂直線
            g.DrawLine(pb2, 54 * selpix, 243 * selpix, 54 * selpix, 285 * selpix)

            '加工マークの表示
            Dim b As New Font("ＭＳ 明朝", 50, FontStyle.Regular)
            g.DrawString("▽", b, Brushes.Black, 160 * selpix, 25 * selpix)

            '文字のフォント指定。
            Dim c As New Font("ＭＳ Ｐゴシック", txts, FontStyle.Bold)
            Dim d As New Font("ＭＳ Ｐゴシック", txtm, FontStyle.Bold)
            Dim f As New Font("ＭＳ Ｐゴシック", fxize, FontStyle.Bold) '数値の大きさ 寸法数値のインスタンス
            Dim h As New Font("ＭＳ Ｐゴシック", comsiz, FontStyle.Bold) '公差数値の大きさのインスタンス

            '図面枠内の文字表示
            g.DrawString("寸法区分", f, Brushes.Black, 23 * selpix, 244 * selpix)
            g.DrawString("   　0.5以上　  　 6以下", f, Brushes.Black, 11.5 * selpix, 250 * selpix)
            g.DrawString("     6を超え    　30以下", f, Brushes.Black, 11.5 * selpix, 256 * selpix)
            g.DrawString("   30を超え     120以下", f, Brushes.Black, 11.5 * selpix, 262 * selpix)
            g.DrawString(" 120を超え　   315以下", f, Brushes.Black, 11.5 * selpix, 268 * selpix)
            g.DrawString(" 315を超え　 1000以下", f, Brushes.Black, 11.5 * selpix, 274 * selpix)
            g.DrawString("1000を超え   2000以下", f, Brushes.Black, 11.5 * selpix, 280 * selpix)

            '許容さの表示
            g.DrawString("許容差", f, Brushes.Black, 54 * selpix, 244 * selpix)
            g.DrawString("±0.1", f, Brushes.Black, 55 * selpix, 250 * selpix)
            g.DrawString("±0.2", f, Brushes.Black, 55 * selpix, 256 * selpix)
            g.DrawString("±0.3", f, Brushes.Black, 55 * selpix, 262 * selpix)
            g.DrawString("±0.5", f, Brushes.Black, 55 * selpix, 268 * selpix)
            g.DrawString("±0.8", f, Brushes.Black, 55 * selpix, 274 * selpix)
            g.DrawString("±1.2", f, Brushes.Black, 55 * selpix, 280 * selpix)

            '大枠内の文字の表示
            g.DrawString("材質", f, Brushes.Black, 69 * selpix, 244 * selpix)
            g.DrawString("熱処理　硬度", f, Brushes.Black, 69 * selpix, 255 * selpix)
            g.DrawString("表面処理", f, Brushes.Black, 69 * selpix, 265 * selpix)
            g.DrawString("図法", f, Brushes.Black, 127 * selpix, 244 * selpix)
            g.DrawString("承認", f, Brushes.Black, 127 * selpix, 255 * selpix)
            g.DrawString("図番", f, Brushes.Black, 127 * selpix, 265 * selpix)
            g.DrawString("品名", f, Brushes.Black, 127 * selpix, 275 * selpix)
            g.DrawString("尺度", f, Brushes.Black, 162 * selpix, 244 * selpix)
            g.DrawString("製図", f, Brushes.Black, 162 * selpix, 255 * selpix)
            g.DrawString("山本ねじ工販株式会社", c, Brushes.Black, 69 * selpix, 278 * selpix)

            '材質ナンバーの大文字化
            Dim workns As String '材質ナンバー
            Dim workn As String
            workns = TextBox3.Text
            workn = UCase(workns)

            'メソッドからの戻り値
            Dim mtans = mtmsd()

            Dim syakudo As Decimal  '尺度pixs
            syakudo = pixs / 4
            g.DrawString("三角法", d, Brushes.Black, 135 * selpix, 246 * selpix)
            g.DrawString("六角ボルト", d, Brushes.Black, 135 * selpix, 277 * selpix)
            g.DrawString("HH" & txt1 & "X" & txt2ans & workn, d, Brushes.Black, 135 * selpix, 267 * selpix)
            g.DrawString(syakudo & "/" & "1", d, Brushes.Black, 175 * selpix, 246 * selpix)
            g.DrawString(mtans.Item1, d, Brushes.Black, 80 * selpix, 246 * selpix)
            g.DrawString(mtans.Item2, f, Brushes.Black, 69 * selpix, 260 * selpix)

            'ココからはボルトの画像表示
            Dim reader As New IO.StreamReader(Application.StartupPath & "\" & HEX_UBOLT, System.Text.Encoding.GetEncoding("shift-jis"))
            Dim items() As String  ' CSVの各項目の配列
            Dim kodo As String   '（0）コード
            Dim yobi As String   '（1）呼び
            Dim dskij As String  '（2）胴部分の径
            Dim ds0 As String    '（3）胴部分の径０公差
            Dim dsms As String   '（4）胴部分の径の－公差
            Dim kkij As String   '（5）頭部の厚み
            Dim kpums As String  '（6）頭部の厚み±公差
            Dim skij As String  '（7）Ｈ幅
            Dim s0 As String  '（8）Ｈ幅　０公差
            Dim sms As String  '（9）Ｈ幅　－公差
            Dim eyaku As String  '（10）頭部外径
            Dim dk As String  '（11）頭部端面径
            Dim r As String  '（12）隅Ｒ
            '(13)は現在ＣＳＶファイルが空欄のためここには表示しない。
            Dim z As String  '（14）先端面取り
            Dim tepa As Decimal = 0.577  'tan30の値
            Dim teplin As Decimal  '頭部xのテーパー開始点座標
            Dim line As String   'ＣＳＶファイルの１行

            line = reader.ReadLine

            Do Until IsNothing(line)
                items = line.Split(", ")
                kodo = items(0)
                yobi = items(1)
                dskij = items(2)
                ds0 = items(3)
                dsms = items(4)
                kkij = items(5)
                kpums = items(6)
                skij = items(7)
                s0 = items(8)
                sms = items(9)
                eyaku = items(10)
                dk = items(11)
                r = items(12)
                z = items(14)

                kodo = kodo.Replace("""", "")
                yobi = yobi.Replace("""", "")
                dskij = dskij.Replace("""", "")
                ds0 = ds0.Replace("""", "")
                dsms = dsms.Replace("""", "")
                kkij = kkij.Replace("""", "")
                kpums = kpums.Replace("""", "")
                skij = skij.Replace("""", "")
                s0 = s0.Replace("""", "")
                sms = sms.Replace("""", "")
                eyaku = eyaku.Replace("""", "")
                dk = dk.Replace("""", "")
                r = r.Replace("""", "")
                z = z.Replace("""", "")
                If txt1 = kodo Then
                    Dim dskijp As Decimal = CDec(dskij) * pixs 'dskij*pixs を dskijpに変換
                    Dim zp As Decimal = CDec(z) * pixs
                    Dim kkijp As Decimal = CDec(kkij * pixs) 'kkij* pixsをにkkijp変換
                    Dim skijp As Decimal = CDec(skij) * pixs   'skij * pixsをskijpに変換
                    Dim eyakup As Decimal = CDec(eyaku) * pixs  'eyaku * pixsをeyakupに変換
                    Dim dkp As Decimal = CDec(dk) * pixs  'CDec(dk) * pixsを dkpに変換  
                    Dim tobst As Decimal  '30度テーパー部のライン(x2-x1)の値
                    Dim dkh1 As Decimal  'yを求める
                    Dim zc As Decimal = CDec(z) 'zの Decimal化
                    '座面のライン
                    g.DrawLine(pb2, xsent + kkijp, ysent - eyakup / 2, xsent + kkijp, ysent + eyakup / 2)
                    'ボルト頭部端面
                    g.DrawLine(pb2, xsent, ysent - dkp / 2, xsent, ysent + dkp / 2)
                    '30度テーパー部のライン
                    teplin = xsent + ((eyakup / 2) - (dkp / 2)) * tepa  '上下兼用
                    g.DrawLine(pb2, xsent, ysent - (dkp / 2), teplin, ysent - eyakup / 2)
                    g.DrawLine(pb2, xsent, ysent + dkp / 2, teplin, ysent + eyakup / 2)
                    '頭部外径ライン
                    g.DrawLine(pb2, teplin, ysent - eyakup / 2, xsent + kkijp, ysent - eyakup / 2)
                    g.DrawLine(pb2, teplin, ysent + eyakup / 2, xsent + kkijp, ysent + eyakup / 2)
                    '頭部六角表示中ライン　
                    Dim hl As Decimal   '頭部六角表示中ライン　　公式　ｈｌ＝ｈ×tan30
                    hl = skijp * tepa    '頭部六角表示中ラインの間隔長さ
                    g.DrawLine(pb2, teplin, ysent - hl / 2, xsent + kkijp, ysent - hl / 2)
                    g.DrawLine(pb2, teplin, ysent + hl / 2, xsent + kkijp, ysent + hl / 2)
                    ' ｛dkから頭部六角表示中ラインhiを結ぶ円弧｝
                    '公式　R=dkh1 * dkh1/8/ tobst+ tobst/2
                    tobst = ((eyakup / 2) - (dkp / 2)) * tepa  '30度テーパー部のライン(x2-x1)の値
                    'dkh1を求める。
                    Dim r1 As Decimal  ''頭部六角表示中ライン外側Ｒ
                    dkh1 = ((dkp / 2) - (hl / 2)) * 2
                    r1 = dkh1 * dkh1 / 8 / tobst + tobst / 2

                    'メソッドからの戻り値
                    Dim aen = asnd()
                    g.DrawArc(pb2, xsent, ysent - dkp / 2 - r1, r1 * 2, r1 * 2, 180 - aen.Item1, aen.Item1)
                    g.DrawArc(pb2, xsent, ysent + dkp / 2 - r1, r1 * 2, r1 * 2, 180, aen.Item1)
                    '頭部六角表示中ラインを結ぶ円弧のライン
                    '公式　r2=hl*hl/8/tobst+tobst/2
                    Dim r2 As Decimal  '頭部六角表示中ラインを結ぶ円弧
                    r2 = hl * hl / 8 / tobst + tobst / 2
                    g.DrawArc(pb2, xsent, ysent - r2, r2 * 2, r2 * 2, 180 - aen.Item2, aen.Item2 * 2)

                    '胴部Ｌのライン
                    Dim llinep As Decimal = lline * pixs
                    If lline > 100 Then   '胴部Ｌのラインが長く図面からはみ出さないための処理
                        llinep = 100 * pixs
                    End If
                    '胴部Ｌのライン,面取り部を加味
                    g.DrawLine(pb2, xsent + kkijp, ysent - dskijp / 2, xsent + kkijp + llinep - zp, ysent - dskijp / 2)
                    g.DrawLine(pb2, xsent + kkijp, ysent + dskijp / 2, xsent + kkijp + llinep - zp, ysent + dskijp / 2)

                    '先端部のライン,面取り部を加味
                    g.DrawLine(pb2, xsent + kkijp + llinep, ysent - dskijp / 2 + zp, xsent + kkijp + llinep, ysent + dskijp / 2 - zp)

                    '面取り部のライン
                    g.DrawLine(pb2, xsent + kkijp + llinep - zp, ysent - dskijp / 2, xsent + kkijp + llinep, ysent - dskijp / 2 + zp)
                    g.DrawLine(pb2, xsent + kkijp + llinep - zp, ysent + dskijp / 2, xsent + kkijp + llinep, ysent + dskijp / 2 - zp)

                    'ネジ開始のライン
                    g.DrawLine(pb2, xsent + kkijp + llinep - zp, ysent - dskijp / 2, xsent + kkijp + llinep - zp, ysent + dskijp / 2)

                    'ネジ長さは値を返すメソッドで対応
                    Dim nejiline = nejians()

                    Dim nejcd As Decimal = CDec(nejiline.Item1)  'ネジ長さを取得
                    Dim nejcdp As Decimal = nejcd * pixs

                    '胴部Ｌのラインが長く図面からはみ出さないための処理をしたときに胴部に斜め線を入れる。
                    Dim zp5 As Decimal = 0.5 * zp
                    If lline > 100 Then
                        g.DrawLine(pb2, xsent + kkijp + (llinep - nejcdp) / 2 - zp5, ysent - dskijp / 2, xsent + kkijp + (llinep - nejcdp) / 2 - 3 * zp5, ysent + dskijp / 2)
                        g.DrawLine(pb2, xsent + kkijp + (llinep - nejcdp) / 2 - 2 * zp5, ysent - dskijp / 2, xsent + kkijp + (llinep - nejcdp) / 2 - 4 * zp5, ysent + dskijp / 2)
                    End If

                    'ネジ谷ライン  水平線

                    If lline < nejcd + 3 * zc Then  '全ネジの場合
                        nejcdp = llinep
                    End If
                    g.DrawLine(pb2, xsent + kkijp + llinep, ysent - dskijp / 2 + zp, xsent + kkijp + llinep - nejcdp + zp, ysent - dskijp / 2 + zp)
                    g.DrawLine(pb2, xsent + kkijp + llinep, ysent + dskijp / 2 - zp, xsent + kkijp + llinep - nejcdp + zp, ysent + dskijp / 2 - zp)
                    'ネジ谷ライン　45°斜め線
                    g.DrawLine(pb2, xsent + kkijp + llinep - nejcdp + zp, ysent - dskijp / 2 + zp, xsent + kkijp + llinep - nejcdp, ysent - dskijp / 2)
                    g.DrawLine(pb2, xsent + kkijp + llinep - nejcdp + zp, ysent + dskijp / 2 - zp, xsent + kkijp + llinep - nejcdp, ysent + dskijp / 2)
                    '不完全ネジ部の垂直線
                    g.DrawLine(pb2, xsent + kkijp + llinep - nejcdp + zp, ysent - dskijp / 2 + zp, xsent + kkijp + llinep - nejcdp + zp, ysent + dskijp / 2 - zp)

                    'ここからは六角部のライン設定
                    '頭部円のライン
                    g.DrawEllipse(pb2, xhsnt - dkp / 2, ysent - dkp / 2, dkp, dkp)

                    '正六角形のライン
                    Dim hex As Point() = {New Point(xhsnt, ysent - eyakup / 2), New Point(xhsnt + skijp / 2, ysent - hl / 2), New Point(xhsnt + skijp / 2, ysent + hl / 2), New Point(xhsnt, ysent + eyakup / 2), New Point(xhsnt - skijp / 2, ysent + hl / 2), New Point(xhsnt - skijp / 2, ysent - hl / 2), New Point(xhsnt, ysent - eyakup / 2)}
                    g.DrawPolygon(pb2, hex)

                    'ここからは寸法線の設定
                    'ネジ部の寸法線
                    '全長の寸法線  垂直線
                    g.DrawLine(pb2, xsent + kkijp + llinep, ysent - dskijp / 2 + zp, xsent + kkijp + llinep, ysent - dkp / 2 - 44 * sizpix)
                    g.DrawLine(pb2, xsent, ysent - dkp / 2, xsent, ysent - dkp / 2 - 44 * sizpix)

                    '頭部厚み寸法線
                    g.DrawLine(pb2, xsent + kkijp, ysent - eyakup / 2, xsent + kkijp, ysent - eyakup / 2 - 31 * sizpix)

                    '有効ネジ長さの寸法線　垂直線
                    If lline > nejcd + 3 * zc Then
                        g.DrawLine(pb2, xsent + kkijp + llinep - nejcdp + zp, ysent - dskijp / 2, xsent + kkijp + llinep - nejcdp + zp, ysent - dskijp / 2 - 24 * sizpix)
                    End If
                    '頭部dkの寸法線　水平線
                    g.DrawLine(pb2, xsent, ysent - dkp / 2, xsent - 10 * sizpix, ysent - dkp / 2)
                    g.DrawLine(pb2, xsent, ysent + dkp / 2, xsent - 10 * sizpix, ysent + dkp / 2)

                    '30°寸法線
                    Dim siztan As Decimal
                    siztan = Math.Tan(30 / 180 * Math.PI)
                    g.DrawLine(pb2, xsent, ysent + dkp / 2, xsent, ysent + dkp / 2 + 15 * sizpix)
                    g.DrawLine(pb2, xsent, ysent + dkp / 2, xsent + siztan * (15 * sizpix), ysent + dkp / 2 + 15 * sizpix)

                    'ここからは六角部の寸法線
                    '六角形の寸法線    垂直線
                    g.DrawLine(pb2, xhsnt + skijp / 2, ysent - hl / 2, xhsnt + skijp / 2, ysent - hl / 2 - 17 * sizpix)
                    g.DrawLine(pb2, xhsnt - skijp / 2, ysent - hl / 2, xhsnt - skijp / 2, ysent - hl / 2 - 17 * sizpix)

                    'ここから←→付きの寸法線
                    pb2.CustomStartCap = New Drawing2D.AdjustableArrowCap(3, 3)
                    pb2.CustomEndCap = New Drawing2D.AdjustableArrowCap(3, 3)
                    'ネジ部の寸法線
                    '30°寸法線の円弧表示
                    Dim sizr1 As Decimal
                    sizr1 = 10 * sizpix
                    g.DrawArc(pb2, xsent - sizr1, ysent + dkp / 2 - sizr1, sizr1 * 2, sizr1 * 2, 60, 30)
                    '全長の寸法線水平線
                    g.DrawLine(pb2, xsent, ysent - dskijp / 2 - 46 * sizpix, xsent + kkijp + llinep, ysent - dskijp / 2 - 46 * sizpix)
                    '頭部厚みの寸法線　水平線
                    g.DrawLine(pb2, xsent, ysent - dkp / 2 - 32 * sizpix, xsent + kkijp, ysent - dkp / 2 - 32 * sizpix)
                    '胴部の長さ寸法線　　水平線
                    g.DrawLine(pb2, xsent + kkijp, ysent - dkp / 2 - 32 * sizpix, xsent + kkijp + llinep, ysent - dkp / 2 - 32 * sizpix)
                    '端面ｄｋの寸法線　　垂直線
                    g.DrawLine(pb2, xsent - 8 * sizpix, ysent - dkp / 2, xsent - 8 * sizpix, ysent + dkp / 2)
                    '有効ネジ長さの寸法線　　水平線  全ネジの場合はキャンセルする。
                    If lline > nejcd + 3 * zc Then
                        g.DrawLine(pb2, xsent + kkijp + llinep - nejcdp + zp, ysent - dskijp / 2 - 23 * sizpix, xsent + kkijp + llinep, ysent - dskijp / 2 - 23 * sizpix)
                    End If

                    '胴部分の径(dskij)の寸法法線　垂直線 +0.5*zpにする  全ネジの場合はキャンセルする。
                    If lline > nejcd + 3 * zc Then
                        g.DrawLine(pb2, xsent + kkijp + (llinep - nejcdp) / 2 + zp5, ysent - dskijp / 2, xsent + kkijp + (llinep - nejcdp) / 2 + zp5, ysent + dskijp / 2)
                    End If

                    'ここからは六角部の寸法線
                    'Ｈ幅の寸法線　　水平線
                    g.DrawLine(pb2, xhsnt + skijp / 2, ysent - hl / 2 - 16 * sizpix, xhsnt - skijp / 2, ysent - hl / 2 - 16 * sizpix)

                    'ここからは寸法線←線の表示
                    pb2.CustomStartCap = New Drawing2D.AdjustableArrowCap(3, 3)
                    pb2.CustomEndCap = New Drawing2D.AdjustableArrowCap(0, 0)
                    'ネジ部先端の面取り寸法線　30°線
                    Dim menxp As Decimal
                    Dim menyp As Decimal
                    menxp = 10 * (Math.Cos(60 / 180 * Math.PI)) * sizpix
                    menyp = 10 * (Math.Sin(60 / 180 * Math.PI)) * sizpix
                    g.DrawLine(pb2, xsent + kkijp + llinep, ysent - dskijp / 2 + zp, xsent + kkijp + llinep + menxp, ysent - dskijp / 2 - menyp)
                    '呼び径の表示線　　30°線 
                    Dim yoby As Decimal = 4 * sizpix
                    Dim yotanp As Decimal
                    yotanp = yoby * Math.Tan(30 / 180 * Math.PI)
                    g.DrawLine(pb2, xsent + kkijp + llinep - 2 * zp, ysent + dskijp / 2, xsent + kkijp + llinep - 2 * zp + yotanp, ysent + dskijp / 2 + yoby)
                    '隅Ｒの寸法線　　30°線
                    Dim sumirxp As Decimal
                    Dim sumiryp As Decimal
                    sumirxp = 8 * (Math.Sin(30 / 180 * Math.PI)) * sizpix
                    sumiryp = 8 * (Math.Cos(30 / 180 * Math.PI)) * sizpix
                    g.DrawLine(pb2, xsent + kkijp, ysent + dskijp / 2, xsent + kkijp + sumirxp, ysent + dskijp / 2 + sumiryp)
                    '胴部径の寸法線
                    Dim dstanp As Decimal
                    dstanp = 30 * sizpix * Math.Tan(30 / 180 * Math.PI)
                    If lline > nejcd + 3 * zc Then
                        g.DrawLine(pb2, xsent + kkijp + (llinep - nejcdp) / 2 + zp5, ysent + dskijp / 2, xsent + kkijp + (llinep - nejcdp) / 2 + zp5 + dstanp, ysent + dskijp / 2 + 15 * sizpix)
                        pb2 = New Pen(Color.Black, 2)  '線のインスタンス（この線はー銭です）
                        g.DrawLine(pb2, xsent + kkijp + (llinep - nejcdp) / 2 + zp5 + dstanp, ysent + dskijp / 2 + 15 * sizpix, xsent + kkijp + (llinep - nejcdp) / 2 + zp5 + dstanp + 20 * sizpix, ysent + dskijp / 2 + 15 * sizpix)
                    End If

                    'ここからは寸法の文字表示
                    '30°角度の表示
                    g.DrawString("30°", f, Brushes.Black, xsent, ysent + dkp / 2 + 11 * sizpix)
                    '全長寸法の数値  （寸法線とＸは一文字txtpix　　Ｙは4 * txtpix違い）
                    g.DrawString("(" & lline + kkij & ")", f, Brushes.Black, (xsent + kkijp + llinep + xsent) / 2 - 4 * sizpix, ysent - dskijp / 2 - 50 * sizpix)
                    '頭部の厚み寸法  kkij （5）頭部の厚み
                    Dim txt9 As Decimal  '文字表示を可変式にする。
                    txt9 = TextBox9.Text
                    g.DrawString(kkij, f, Brushes.Black, xsent + kkijp / 2 - 4 * sizpix + txt9 * sizpix, ysent - dkp / 2 - 38 * sizpix)
                    '頭部の厚み寸法公差　 kpums （6）頭部の厚み±公差
                    g.DrawString(kpums, h, Brushes.Black, xsent + kkijp / 2 + 4 * sizpix + txt9 * sizpix, ysent - dkp / 2 - 39 * sizpix)
                    'TextBox2に入力された胴部の長さ　 lline 
                    g.DrawString(lline, f, Brushes.Black, xsent + kkijp + llinep / 2 - 6 * sizpix, ysent - dkp / 2 - 36 * sizpix)

                    '胴部の長さの公差　　　len margin.csvファイルを読み込むメソッドから値を取得する
                    Dim loca As Decimal
                    If lline < 100 Then
                        loca = -1 * sizpix
                    ElseIf lline >= 100 Then
                        loca = 1 * sizpix
                    End If
                    Dim margin As String = lenmsd()
                    g.DrawString(margin, h, Brushes.Black, xsent + kkijp + llinep / 2 + loca, ysent - dkp / 2 - 36 * sizpix)
                
                '全ネジの場合の処理

                    If lline < nejcd + 3 * zc Then
                        g.DrawString("全ネジ", f, Brushes.Black, xsent + kkijp + llinep / 2 + 1 * sizpix, ysent - dskijp / 2 - 60 * sizpix)
                    End If

                'ネジ先端部のＣ面取り
                g.DrawString("Ｃ" & z, f, Brushes.Black, xsent + kkijp + llinep + menxp - 5 * sizpix, ysent - dskijp / 2 - menyp - 4 * sizpix)
                '全ネジではないときの有効ネジ長さ 全ネジのときはキャンセル
                    If lline > nejcd + 3 * zc Then
                        g.DrawString(nejiline.Item1, f, Brushes.Black, xsent + kkijp + llinep - nejcdp / 2 - 2 * zp, ysent - dskijp / 2 - 23 * sizpix - 4 * sizpix)
                    End If

                    '有効ネジ長さの公差　　
                    Dim smrgn = nejians()
                    '全ネジのときはキャンセルする
                    If lline > nejcd + 3 * zc Then
                        g.DrawString(smrgn.Item3, h, Brushes.Black, xsent + kkijp + llinep - nejcdp / 2 + 5 * sizpix, ysent - dskijp / 2 - 23 * sizpix - 3 * sizpix)
                        g.DrawString(smrgn.Item2, h, Brushes.Black, xsent + kkijp + llinep - nejcdp / 2 + 2 * sizpix, ysent - dskijp / 2 - 23 * sizpix - 6 * sizpix)
                    End If

                '隅Ｒの表示
                g.DrawString("R" & r, f, Brushes.Black, xsent + kkijp + sumirxp - 2 * sizpix, ysent + dskijp / 2 + sumiryp)
                'ネジサイズの表示
                g.DrawString(yobi, f, Brushes.Black, xsent + kkijp + llinep - 2 * zp + yotanp - 3 * sizpix, ysent + dskijp / 2 + yoby)
                '六角部(skij)（7）Ｈ幅の表示
                g.DrawString(skij, f, Brushes.Black, xhsnt - 7 * sizpix, ysent - hl / 2 - 16 * sizpix - 5 * sizpix)
                '六角部　Ｈ幅の公差の表示　０公差(s0)
                    g.DrawString(s0, h, Brushes.Black, xhsnt + 6 * sizpix, ysent - hl / 2 - 16 * sizpix - 7 * sizpix)
                '六角部　Ｈ幅の公差の表示  －公差(sms)
                    g.DrawString(sms, h, Brushes.Black, xhsnt + 4 * sizpix, ysent - hl / 2 - 16 * sizpix - 4 * sizpix)
                '胴部分の径の表示 (dskij)
                    If lline > nejcd + 3 * zc Then
                        g.DrawString("Φ" & dskij, f, Brushes.Black, xsent + kkijp + (llinep - nejcdp) / 2 + zp5 + dstanp, ysent + dskijp / 2 + 11 * sizpix)
                        '胴部分の径０公差の表示 (ds0)
                        g.DrawString(ds0, h, Brushes.Black, xsent + kkijp + (llinep - nejcdp) / 2 + zp5 + dstanp + 17 * sizpix, ysent + dskijp / 2 + 9 * sizpix)
                        '胴部分の径の－公差の表示(dsms)
                        g.DrawString(dsms, h, Brushes.Black, xsent + kkijp + (llinep - nejcdp) / 2 + zp5 + dstanp + 15 * sizpix, ysent + dskijp / 2 + 12 * sizpix)
                    End If
                '頭部端面径の表示 (dk)
                Dim txt10 As Decimal '端面径dkの表示位置を可変式にする。
                txt10 = TextBox10.Text
                '座標(30, 10)に描画するため、ワールド変換を平行移動
                g.TranslateTransform(xsent - 15 * sizpix + txt10 * sizpix, ysent + 6 * sizpix)

                'ワールド変換行列を度回転する
                g.RotateTransform(270)

                g.DrawString("Φ" & dk, f, Brushes.Black, 0, 0)
                End If
                line = reader.ReadLine
            Loop
            c.Dispose()
            d.Dispose()
            f.Dispose()
            g.Dispose()
            h.Dispose()

            savepic()
            openpic()
        Catch ex As Exception
            MsgBox("エラー　入力文字を確認してください。" & vbNewLine & ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub
    'ねじ長さの値を取得と有効ネジ長さの公差のメソッド
    Private Function nejians() As Tuple(Of String, String, String)
        Dim reader As New IO.StreamReader(Application.StartupPath & "\" & TENP_FILE, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim items() As String   '各項目をあらわす配列
        Dim kodo As String  '（0）コード
        Dim std As String  '（1）ネジ長さ標準
        Dim lon As String  '（2）ネジ長さロング
        Dim atte As String '(3)ネジ長さの表記無しのため注意喚起
        Dim line As String  'CSVの１行
        Dim ans1 As String   '返す値の変数

        'TextBox1の文字
        Dim txt As String
        txt = TextBox1.Text

        'TextBox1に入力されたtxt1の大文字化
        Dim txt1 As String
        txt1 = UCase(txt)

        'TextBox2のStringをDecimalに変換処理
        Dim lline As Decimal  '胴部Ｌのライン
        Dim txt2string As String 'TextBox2の初期値はString
        txt2string = TextBox2.Text  '胴部Ｌのライン
        lline = CDec(txt2string)

        line = reader.ReadLine
        Do Until IsNothing(line)
            items = line.Split(",")
            kodo = items(0)
            std = items(1)
            lon = items(2)
            atte = items(3)

            kodo = kodo.Replace("""", "")
            std = std.Replace("""", "")
            lon = lon.Replace("""", "")
            atte = atte.Replace("""", "")

            If txt1 = kodo Then
                If 160 > lline Then
                    ans1 = std
                ElseIf lline >= 160 Then
                    ans1 = lon
                End If
            End If
            line = reader.ReadLine
        Loop
        reader.Close()

        '有効ネジ長さのＣＳＶファイルの読み込み
        Dim sreader As New IO.StreamReader(Application.StartupPath & "\" & SCREW_MARGIN, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim sline As String     'ＣＳＶファイルの１行
        Dim small As String    '(0)～を超え
        Dim larg As String     '(1)～以下
        Dim prs As String      '(2)＋の公差
        Dim zero As String     '(3)0の公差
        Dim sitem() As String  'CSVの各項目の配列
        Dim ans2 As String     '＋の公差の返す値
        Dim ans3 As String     '0の公差の返す値

        sline = sreader.ReadLine

        Do Until IsNothing(sline)
            sitem = sline.Split(",")
            small = sitem(0)
            larg = sitem(1)
            prs = sitem(2)
            zero = sitem(3)

            small = small.Replace("""", "")
            larg = larg.Replace("""", "")
            prs = prs.Replace("""", "")
            zero = zero.Replace("""", "")
            ans1 = ans1
            If CDec(small) < CDec(ans1) AndAlso CDec(larg) >= CDec(ans1) Then
                ans2 = prs
                ans3 = zero
            End If
            sline = sreader.ReadLine
        Loop
        sreader.Close()

        Return Tuple.Create(item1:=ans1, item2:=ans2, item3:=ans3)

    End Function

    'dkから頭部六角表示中ラインhiを結ぶ円弧の始点角の計算
    Private Function asnd() As Tuple(Of Decimal, Decimal)
        Dim reader As New IO.StreamReader(Application.StartupPath & "\" & HEX_UBOLT, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim items() As String   '各項目をあらわす配列
        Dim kodo As String   '（0）コード
        Dim yobi As String   '（1）呼び
        Dim dskij As String  '（2）胴部分の径
        Dim ds0 As String    '（3）胴部分の径０公差
        Dim dsms As String   '（4）胴部分の径の－公差
        Dim kkij As String   '（5）頭部の厚み
        Dim kpums As String  '（6）頭部の厚み±公差
        Dim skij As String  '（7）Ｈ幅
        Dim eyaku As String  '（10）頭部外径
        Dim dk As String  '（11）頭部端面径
        Dim r As String  '（12）隅Ｒ
        Dim r1 As Decimal  ''頭部六角表示中ライン外側Ｒ
        Dim r2 As Decimal  '頭部六角表示中ラインを結ぶ円弧
        Dim hl As Decimal   '頭部六角表示中ライン　　公式　ｈｌ＝ｈ×tan30
        Dim tepa As Decimal = 0.577  'tan30の値
        Dim dkh1 As Decimal  'yを求める
        Dim tobst As Decimal  '30度テーパー部のライン(x2-x1)の値
        Dim r1dkp As Decimal
        Dim r2hi As Decimal
        Dim rans1 As Decimal  'dkから頭部六角表示中ラインhiを結ぶ円弧の終点角の計算結果
        Dim rans2 As Decimal  'dkから頭部六角表示中ラインhiを結ぶ円弧の始点角の計算結果
        Dim line As String  'CSVの１行

        'TextBox1の文字
        Dim txt As String
        txt = TextBox1.Text

        'TextBox1に入力されたtxt1の大文字化
        Dim txt1 As String
        txt1 = UCase(txt)

        line = reader.ReadLine

        Do Until IsNothing(line)
            items = line.Split(",")
            kodo = items(0)
            yobi = items(1)
            dskij = items(2)
            ds0 = items(3)
            dsms = items(4)
            kkij = items(5)
            kpums = items(6)
            skij = items(7)
            eyaku = items(10)
            dk = items(11)
            r = items(12)

            kodo = kodo.Replace("""", "")
            yobi = yobi.Replace("""", "")
            dskij = dskij.Replace("""", "")
            ds0 = ds0.Replace("""", "")
            dsms = dsms.Replace("""", "")
            kkij = kkij.Replace("""", "")
            kpums = kpums.Replace("""", "")
            skij = skij.Replace("""", "")
            eyaku = eyaku.Replace("""", "")
            dk = dk.Replace("""", "")
            r = r.Replace("""", "")

            If txt1 = kodo Then
                Dim dkp As Decimal = CDec(dk) * pixs  'CDec(dk) * pixsを dkpに変換 
                Dim skijp As Decimal = CDec(skij) * pixs   'skij * pixsをskijpに変換
                Dim eyakup As Decimal = CDec(eyaku) * pixs  'eyaku * pixsをeyakupに変換
                hl = skijp * tepa   '頭部六角表示中ラインの間隔長さ
                tobst = ((eyakup / 2) - (dkp / 2)) * tepa  '30度テーパー部のライン(x2-x1)の値
                dkh1 = ((dkp / 2) - (hl / 2)) * 2
                r1 = dkh1 * dkh1 / 8 / tobst + tobst / 2
                r1dkp = (dkp / 2 - hl / 2) / r1
                rans1 = (Math.Asin(r1dkp)) * (180 / Math.PI) 'dkから頭部六角表示中ラインhiを結ぶ円弧の終点角の計算

                r2 = hl * hl / 8 / tobst + tobst / 2
                r2hi = (hl / 2) / r2
                rans2 = (Math.Asin(r2hi)) * (180 / Math.PI) 'dkから頭部六角表示中ラインhiを結ぶ円弧の始点角の計算
                
            End If
            line = reader.ReadLine

        Loop
        reader.Close()

        Return Tuple.Create(item1:=rans1, item2:=rans2)

    End Function
    '胴部長さの公差のメソッド
    Private Function lenmsd() As String
        Dim reader As New IO.StreamReader(Application.StartupPath & "\" & LEN_MARGIN, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim line As String     'ＣＳＶファイルの１行
        Dim small As String    '(0)～を超え 
        Dim larg As String     '(1)～以下
        Dim prsmns As String   '(2)±の公差
        Dim item() As String   'CSVの各項目の配列
        Dim marginans As String   '返す値

        'TextBox2のStringをDecimalに変換処理
        Dim lline As Decimal  '胴部Ｌのライン
        Dim txt2string As String 'TextBox2の初期値はString
        txt2string = TextBox2.Text  '胴部Ｌのライン
        lline = CDec(txt2string)

        line = reader.ReadLine
        Do Until IsNothing(line)
            item = line.Split(",")
            small = item(0)
            larg = item(1)
            prsmns = item(2)

            small = small.Replace("""", "")
            larg = larg.Replace("""", "")
            prsmns = prsmns.Replace("""", "")

            If CDec(small) < lline AndAlso CDec(larg) >= lline Then
                marginans = prsmns
            End If
            line = reader.ReadLine
        Loop
        reader.Close()
        Return marginans
    End Function

    '材質 熱処理　硬度のメソッド
    Private Function mtmsd() As Tuple(Of String, String)
        Dim mread As New IO.StreamReader(Application.StartupPath & "\" & MATERIAL_FILE, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim mline As String   'ＣＳＶファイルの１行
        Dim mitem() As String  'CSVの各項目の配列
        Dim kohdo As String   '(0)
        Dim work As String  '(1)材質
        Dim koudo As String '(2)熱処理　硬度
        Dim workns As String '材質ナンバー
        Dim mans1 As String   '(1)材質
        Dim mans2 As String   '(2)熱処理　硬度
        '材質ナンバーの大文字化
        Dim workn As String
        workns = TextBox3.Text
        workn = UCase(workns)

        mline = mread.ReadLine
        Do Until IsNothing(mline)
            mitem = mline.Split(",")
            kohdo = mitem(0)
            work = mitem(1)
            koudo = mitem(2)

            kohdo = kohdo.Replace("""", "")
            work = work.Replace("""", "")
            koudo = koudo.Replace("""", "")
            If workn = kohdo Then
                mans1 = work
                mans2 = koudo
            End If
            mline = mread.ReadLine
        Loop
        mread.Close()
        Return Tuple.Create(item1:=mans1, item2:=mans2)
    End Function
    '保存のメソッド
    Private Sub savepic()
        If Not (PictureBox1.Image Is Nothing) Then
            PictureBox1.Image.Save(Application.StartupPath & "\" & PICSE_FILE)
        End If
    End Sub
    'Process.Startのメソッド
    Private Sub openpic()
        Process.Start(Application.StartupPath & "\" & PICSE_FILE)
    End Sub

    Private Sub ファイルFToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ファイルFToolStripMenuItem.Click
        MsgBox("現在開発中" & vbNewLine & "使用できません。")
    End Sub
    Private Sub 表示VToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 表示VToolStripMenuItem.Click
        MsgBox("現在開発中" & vbNewLine & "使用できません。")
    End Sub

    Private Sub 印刷ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 印刷ToolStripMenuItem.Click
        MsgBox("現在開発中" & vbNewLine & "使用できません。")
    End Sub

    Private Sub バージョンToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles バージョンToolStripMenuItem.Click
        MsgBox(Application.ProductVersion & vbNewLine & Application.ProductName)
    End Sub

    Private Sub 制作著作ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 制作著作ToolStripMenuItem.Click
        MsgBox("制作" & vbNewLine & "田中　裕之")
    End Sub

    Private Sub 説明書ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 説明書ToolStripMenuItem.Click
        Dim reader As New IO.StreamReader(Application.StartupPath & "\" & "Readme.txt", System.Text.Encoding.GetEncoding("shift-jis"))
        Dim txt1 As String
        txt1 = reader.ReadToEnd
        Dim f As New Form2
        f.Owner = Me
        f.TextBox1.Text = txt1
        f.Show()
        f.TextBox1.DeselectAll()

    End Sub
End Class
